// array.cpp

#include "jpnslisp.h"

extern CELL *NILCell,*TCell,*CHARACTER;

CELL *jcons(CELL *car,CELL *cdr)
{
    CELL *c;

    c = getCell();
    c->attr = 'l';
    c->car = car;
    c->cdr = cdr;
    return c;
}

CELL *jnth(long n,CELL *c)
{
    if (c->attr != 'l') return NULL;
    if (n == 0L) return c->car;
    return jnth(n - 1,c->cdr);
}

CELL *jprenth(long n,CELL *c)
{
    if (c->attr != 'l') return NULL;
    if (n == 0L) return c;
    return jprenth(n - 1,c->cdr);
}

long jnlength(CELL *c)
{
    long i = 0;

    for (;;) {
	if (c->attr != 'l') return i;
	c = c->cdr;
	i++;
    }
}

CELL *SetArray(CELL *top,SYMVAL *loc,long locn)
{
    CELL *c;

    if ((top->cdr)->attr != 'l') goto serror;
    c = eval((top->cdr)->car,loc,locn);
    if (c == NULL) goto serror;
    if (c->attr != 'l') goto serror;
    c->attr = 'a';
    return c;

  serror:
    printf("G[: z^ɐݒł܂B\n");
    return NULL;
}

/*
CELL *aref(CELL *top,SYMVAL *loc,long locn)
{
    CELL *c,*dim,*arr,*shitei,*k;
    long len,n;

    c = top->cdr; // c = (a 4 3 2)
    if (c->attr != 'l') { puts("G[: ܂"); return NULL; }
    arr = eval(c->car,loc,locn); // c->car = a, arr = (3 all ((a b) (c d)) ((e f) (g h))
    if (arr == NULL) return NULL;
    if (arr->attr != 'a') { puts("G[: zł͂܂"); return NULL; }
    dim = arr->car; // dim = 3
    shitei = (top->cdr)->cdr; // shitei = (4 3 2)
    len = jnlength(shitei);  // len = 3
    if (len != ((AINT *)(dim->car))->f) { puts("G[: ܂"); return NULL; }
    arr = (arr->cdr)->cdr; // arr = (((a b) (c d)) ((e f) (g h))
    for (;;) {
	if (shitei->attr != 'l') break;
	if (arr == NULL) arr = NILCell;
	k = eval(shitei->car,loc,locn);
	if (k == NULL) return NULL;
	if (k->attr != 'i') { puts("G[: Ԗڂw肵Ă܂"); return NULL; }
	n = ((AINT *)(k->car))->f;
	if (n < 0) { puts("G[: Ԗڂw肳܂"); return NULL; }
	if (arr == NILCell) return NULL;
        arr = jnth(n,arr);
	shitei = shitei->cdr;
    }
    return arr;
}
*/

/*
CELL *prearef(CELL *top,SYMVAL *loc,long locn)
{
    CELL *c,*dim,*arr,*shitei,*k,*ce,*ck;
    long len,n;

    c = top->cdr; // c = (t a 4 3 2)
    if (c->attr != 'l') { puts("G[: ܂"); return NULL; }
    ck = c;
    c = c->cdr; // c = (a 4 3 2)
    if (c->attr != 'l') { puts("G[: ܂"); return NULL; }
    arr = eval(c->car,loc,locn); // c->car = a, arr = (3 all ((a b) (c d)) ((e f) (g h))
    if (arr == NULL) return NULL;
    if (arr->attr != 'a') { puts("G[: zł͂܂"); return NULL; }

    if (ck->car == TCell) {
	if ((arr->cdr)->car == CHARACTER) {
	    puts("G[: ^ݒł܂");
	    return NULL;
	}
    }

    dim = arr->car; // dim = 3
    shitei = ((top->cdr)->cdr)->cdr; // shitei = (4 3 2)
    len = jnlength(shitei);  // len = 3
    if (len != ((AINT *)(dim->car))->f) { puts("G[: ܂"); return NULL; }
    arr = (arr->cdr)->cdr; // arr = (((a b) (c d)) ((e f) (g h))
    for (;;) {
	if (shitei->attr != 'l') break;
	if (arr == NULL) arr = NILCell;
	k = eval(shitei->car,loc,locn);
	if (k == NULL) return NULL;
	if (k->attr != 'i') { puts("G[: Ԗڂw肵Ă܂"); return NULL; }
	n = ((AINT *)(k->car))->f;
	if (n < 0) { puts("G[: Ԗڂw肳܂"); return NULL; }
	if (arr == NILCell) return NULL;
	ce = jprenth(n,arr);
        arr = jnth(n,arr);
	shitei = shitei->cdr;
    }
    return ce;
}
*/

CELL *ArrayCar(CELL *a)
{
    if (a->attr != 'a') { puts("zł͂܂"); return NULL; }
    return a->car;
}

CELL *ArrayCdr(CELL *a)
{
    if (a->attr != 'a') { puts("zł͂܂"); return NULL; }
    return a->cdr;
}
