; Telephone Book S&S

(load "oop.lsp")

(defclass ctel-book)

(defmethod setup ((obj ctel-book)) )

(defmethod run ((obj ctel-book))
    (let ((part (make-instanse 'cpart)) (num))
	(tell part 'init-tel-table)
	(loop
	    (tell part 'disp-msg)
	    (setq num (read))
	    (case num
		(1 (tell part 'disp))
		(2 (tell part 'input))
		(3 (tell part 'erase))
		(9 (return t)) ) ) ) )

(defclass cpart)

(defmethod disp-msg ((obj cpart))
    (princ "1:\") (terpri)
    (princ "2:") (terpri)
    (princ "3:폜") (terpri)
    (princ "9:I") (terpri) )

(defmethod init-tel-table ((obj cpart)) (tell obj 'write-tel-table (make-hash-table))) 

(defmethod write-tel-table ((obj cpart) htable) (setf (gethash 'tel-table obj) htable))

(defmethod read-tel-table ((obj cpart)) (gethash 'tel-table obj))

(defmethod input ((obj cpart))
    (let ((name) (number))
	(princ 'O͂ĉF)
	(setq name (read))
	(princ 'dbԍ͂ĉF)
	(setq number (read-line))
	(setf (gethash name (tell obj 'read-tel-table)) number) ) )

(defmethod disp ((obj cpart))
    (maphash #'(lambda (key value) (princ key) (spaces 1) (princ value) (terpri)) (tell obj 'read-tel-table)) )

(defmethod erase ((obj cpart))
    (let ((name) (number))
	(princ '폜f[^̖O͂ĉF)
	(setq name (read))
	(remhash name (tell obj 'read-tel-table)) ) )

(setq tel-book (make-instanse 'ctel-book))
(tell tel-book 'setup)
(tell tel-book 'run)
